<?php 
namespace Maillists\Controllers;
use App\Controllers\BaseController;
include_once("I18n.php");
include_once("BxPage.php");
use I18n;
use BxPage;

class MailmanList extends BaseController {
    /**
     * Constructor.
     *
     */
    public function __construct() {
        
    }
    
    /**
     * Index Page for this controller.
     *
     * Past the login page this loads the page for /maillists/mailmanList.
     *
     */
    public function index() {

        $CI =& get_instance();

        //
        //--- Get Ducks lined up: 
        //

        $BX_SESSION = $CI->getBX_SESSION();
        $System = $CI->getSystem();
        $user = $BX_SESSION['loginUser'];

        //
        //-- Prepare Page:
        //

        $factory = $CI->serverScriptHelper->getHtmlComponentFactory("base-maillists", "/maillists/mailmanList");
        $BxPage = $factory->getPage();
        $i18n = $factory->getI18n();

        $BxPage->setGETPOST(array('FORM_GET' => $this->request->getGet(), 'FORM_POST' => $this->request->getPost(), 'AGENT' => $this->request->getUserAgent()));

        //
        //-- Re-Use $errors array from Session data:
        //

        $errors = $BxPage->getErrors();

        //
        // -- Actual page logic start:
        //

        // Get URL strings:
        $get_form_data = $BxPage->getGETPOST('GET');

        //
        //-- Validate GET data:
        //

        if (isset($get_form_data['group'])) {
            // We have a delete transaction:
            $group = $get_form_data['group'];
        }
        else {
            // Don't play games with us!
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403#1");
        }

        //
        //-- Access Rights Check for Vsite level pages:
        // 
        // 1.) Checks if the Group/Vsite exists.
        // 2.) Checks if the user is systemAdministrator
        // 3.) Checks if the user is Reseller of the given Group/Vsite
        // 4.) Checks if the iser is siteAdmin of the given Group/Vsite
        // Returns Forbidden403 if *none* of that is the case.
        if (!$CI->serverScriptHelper->getGroupAdmin($group)) {
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403#2");
        }

        //
        //-- Prepare data:
        //

        // Get data for the Vsite:
        $vsite = $CI->cceClient->getObject('Vsite', array('name' => $group));

        //
        //--- Handle form validation:
        //

        // We start without any active errors:
        $errors = array();

        if (isset($get_form_data['_REMOVE'])) {
            $delErrors = array();
            $_REMOVE = $get_form_data['_REMOVE'];
            if (intval($_REMOVE) > 0) {
                // Verify if it's an 'MailList' Object:
                $obj = $CI->cceClient->get($_REMOVE);
                if ($obj['CLASS'] != "MailList") { 
                    // Yeah, it was a nice try. There is the door!
                    // Nice people say goodbye, or CCEd waits forever:
                    $CI->cceClient->bye();
                    $CI->serverScriptHelper->destructor();
                    Log403Error("/gui/Forbidden403#3");
                }
                // Destroy the Mailing-List Object:
                if (!is_file("/etc/DEMO")) {
                    $ret = $CI->cceClient->destroy($_REMOVE);
                }

                // CCE errors that might have happened during submit to CODB:
                $CCEerrors = $CI->cceClient->errors();
                foreach ($CCEerrors as $object => $objData) {
                    // When we fetch the CCE errors it tells us which field it bitched on. And gives us an error message, which we can return:
                    $delErrors[] = ErrorMessage($i18n->get($objData->message, true, array('key' => $objData->key)) . '<br>&nbsp;');
                }

                // Need to commit to "System" Object "MailList" as well:
                $ret = $CI->cceClient->setObject("System", array('commit' => time()), "MailList");

                // Return to this page and display errors - if there are any.
                $redirect_URL = "/maillists/mailmanList?group=$group";
                $BxPage->ReturnToThisPage($errors, $redirect_URL);
            }
        }

        //
        //-- Generate page:
        //

        // Prepare Page:
        $factory = $CI->serverScriptHelper->getHtmlComponentFactory("base-maillists", "/maillists/mailmanList?group=$group");
        $BxPage = $factory->getPage();
        $BxPage->setFormUrl("/maillists/mailmanList?group=$group");
        $BxPage->setErrors($errors);
        $i18n = $factory->getI18n();

        // Set Menu items:
        $BxPage->setVerticalMenu('base_siteservices');
        $BxPage->setVerticalMenuChild('base_mailmans');
        $page_module = 'base_sitemanage';

        $defaultPage = "basicSettings";
        $block = $factory->getPagedBlock("mailmanList", array($defaultPage));
        $block->setLabel($factory->getLabel('mailmanList', false, array('group' => $vsite['fqdn'])));

        $block->setToggle("#");
        $block->setSideTabs(FALSE);
        $block->setDefaultPage($defaultPage);

        // Only 'manageSite' can modify things on this page.
        // Site admins can view it for informational purposes.
        if ($CI->getAllowed('manageSite')) {
            $is_site_admin = FALSE;
            $access = 'rw';
        }
        elseif (($CI->getAllowed('siteAdmin')) && ($group == $CI->loginUser['site'])) {
            $access = 'r';
            $is_site_admin = TRUE;
        }
        else {
            // Nice people say goodbye, or CCEd waits forever:
            $CI->cceClient->bye();
            $CI->serverScriptHelper->destructor();
            Log403Error("/gui/Forbidden403#4");
        }

        $ScrollList = $factory->getScrollList("mailmanList", array("mailmanNameHeader", "recipientsHeader", "mailmanDescHeader" ,"mailmanActionHeader"), array()); 
        $ScrollList->setAlignments(array("left", "left", "left", "center"));
        $ScrollList->setDefaultSortedIndex('0');
        $ScrollList->setSortOrder('ascending');
        $ScrollList->setSortDisabled(array('3', '4'));
        $ScrollList->setPaginateDisabled(FALSE);
        $ScrollList->setSearchDisabled(FALSE);
        $ScrollList->setSelectorDisabled(FALSE);
        $ScrollList->enableAutoWidth(FALSE);
        $ScrollList->setInfoDisabled(FALSE);
        $ScrollList->setColumnWidths(array("244", "150", "244", "100")); // Max: 739px

        // Add the +Add-Button:
        $xff = $factory->getAddButton("/maillists/mailmanMod?group=$group", '[[palette.add_help]]', "DEMO-OVERRIDE");
        $ScrollList->addButton($xff);

        // Find the MailingLists of this Vsite:
        $oids = $CI->cceClient->findSorted("MailList", "name", array('site' => $group));

        if(count($oids) > 0) { 
            for ($i = 0; $i < count($oids); $i++) {

                $oid = $oids[$i];
                $ml = $CI->cceClient->get($oid, "");

                $members = array();
                // magic variables! if subscriber list is empty, then 'nobody' is the sole recipient
                // parse it out so that we don't show it to the user
                if ($ml['local_recips'] != '&nobody&') {
                    $members = stringToArray($ml['local_recips']);
                }
                $members = array_merge($members, stringToArray($ml['remote_recips']));
                $members = array_merge($members, stringToArray($ml['remote_recips_digest']));
                if ($ml['group']) {
                    $groupText = $i18n->get("groupSubscriber", "", array("group"=>$ml['group']));
                    $members = array_merge($members, (array)"". $groupText . (array)"");
                }

                if ($ml["description"] == "") {
                    $desc = "";
                }
                else {
                    $desc = $i18n->interpolate($ml["description"]);
                }
                $msg = $i18n->get("confirm_removal_of_list", "", array('list' => $ml["name"]));

                // Edit-Button:
                $editButton = $factory->getModifyButton('/maillists/mailmanMod?group=' . $group . '&_TARGET=' . $ml['OID']);
                $editButton->setButtonSize("small");
                if ($BX_SESSION['gui_theme'] === 'adminica') {
                    $editButton->setButtonSize("xs");
                }
                $editButton->setButtonSpecialStyle('square_animated');
                $editButton->setImageOnly(TRUE);
                $editButton->setTarget('_self');

                // Add 'Delete' button:
                $deleteButton = $factory->getModifyButton('/maillists/mailmanList?group=' . $group . '&_REMOVE=' . $ml['OID']);
                $deleteButton->setButtonSize("small");
                if ($BX_SESSION['gui_theme'] === 'adminica') {
                    $deleteButton->setButtonSize("xs");
                }
                $deleteButton->setButtonSpecialStyle('square_animated');
                $deleteButton->setIcon('fa fa-trash-o');
                $deleteButton->setButtonColor('danger');
                $deleteButton->setImageOnly(TRUE);
                $deleteButton->setTarget('_self');
                $deleteButton->setDescription($i18n->getHtml("[[palette.remove_help]]"));
                $deleteButton->addButtonClass('dialog_button');
                $deleteButton->setModal('dialog', '/maillists/mailmanList?group=' . $group . '&_REMOVE=' . $ml['OID']);

                // Add Buttons for Edit/View and Delete:
                $buttons = $editButton->toHtml();
                $buttons .= $deleteButton->toHtml();

                // Cool beans with i18N singular/plural. But we can't get this relieably done in all languages.
                // Hence it's all singular here:
                $ScrollList->addEntry(array(
                        $ml["name"], $i18n->interpolate("[[base-maillists.numSubs]]", array('num' => count($members), 'plural' => '')),
                        $desc,
                        $buttons
                    ), "", false, $i);
            }
        }

        // Show the ScrollList of the MailingLists:
        $xff = $factory->getRawHTML("mailmanList", $ScrollList->toHtml());
        $block->addFormField(
            $xff,
            $factory->getLabel('mailmanList', false, array('group' => $vsite['fqdn'])),
            $defaultPage
        );

        // Add the buttons for those who can edit this page:
        if ($access == 'rw') {
            $block->addButton($factory->getSaveButton($BxPage->getSubmitAction()));
            $block->addButton($factory->getCancelButton("/maillists/mailmanList?group=$group"));
        }

        if ($BX_SESSION['gui_theme'] === 'adminica') {
            // Extra header for the "do you really want to delete" dialog for Adminica:

            $BxPage->setExtraHeaders('
                <script type="text/javascript">
                $(document).ready(function () {
                    // Initialize the dialog with the "Remove" and "Cancel" buttons
                    $("#modalDeleteButton").dialog({
                        modal: true,
                        bgiframe: true,
                        width: 500,
                        height: 280,
                        autoOpen: false,
                        buttons: {
                            "' . $i18n->getHtml("[[palette.remove]]") . '": function() {
                                // Action for the "Remove" button goes here
                                // At this point, we don\'t have the URL yet, it will be set later
                            },
                            "' . $i18n->getHtml("[[palette.cancel]]") . '": function() {
                                $(this).dialog("close");
                            }
                        }
                    });

                    // Attach click event to your delete button
                    $(".dialog_button").click(function (e) {
                        e.preventDefault();
                        
                        // Get the URL from the data-link attribute of the clicked button
                        var deleteUrl = $(this).data("link");

                        // Update the "Remove" button\'s click action dynamically to use the deleteUrl
                        var buttons = $("#modalDeleteButton").dialog("option", "buttons"); // Get the current buttons
                        buttons["' . $i18n->getHtml("[[palette.remove]]") . '"] = function() { // Modify the "Remove" button action
                            window.location.href = deleteUrl; // Redirect to the URL
                            $(this).dialog("close"); // Optionally close the dialog
                        };
                        $("#modalDeleteButton").dialog("option", "buttons", buttons); // Set the updated buttons back

                        // Now open the dialog
                        $("#modalDeleteButton").dialog("open");
                    });
                });
                </script>');
        }
        else {
            // Set extra-footers for do you really want to delete" dialog for Elmer:
            $BxPage->setExtraFooters('
                <script>
                    // Activate the tooltip
                    $(\'[data-toggle="tooltip"]\').tooltip();

                    // Add a click event to open the modal
                    $(\'.dialog_button\').click(function () {
                        event.preventDefault(); // Prevent the default action
                        var url = $(this).data(\'url\');
                        $(\'#modalDeleteButton\').data(\'url\', url);
                        $(\'#dialog\').modal(\'show\');
                    });

                    // Add a click event to the modal\'s deletion button
                    $(\'#modalDeleteButton\').click(function () {
                        var url = $(this).data(\'url\');
                        // Perform your deletion action or redirect to the specified URL
                        window.location.href = url; // Example: Redirect to the URL
                    });
                </script>
            ');
        }

        if ($BX_SESSION['gui_theme'] == 'adminica') {
            // Add hidden Modal for Delete-Confirmation for Adminica:
            $page_body[] = '
                <div class="display_none">
                            <div id="modalDeleteButton" class="dialog_content narrow no_dialog_titlebar" title="' . $i18n->getHtml("[[base-user.removeConfirmQuestion]]") . '">
                                <div class="block">
                                        <div class="section">
                                                <h1>' . $i18n->getHtml("[[base-maillists.removeConfirmQuestion]]") . '</h1>
                                                <div class="dashed_line"></div>
                                                <p>' . $i18n->getHtml("[[base-maillists.ListRemoveConfirmInfo]]") . '</p>
                                        </div>
                                </div>
                            </div>
                </div>';
        }
        else {
            // Add hidden Modal for Delete-Confirmation for Elmer:
            $modal_title = $i18n->getHtml("[[base-maillists.removeConfirmQuestion]]");
            $modal_body = $i18n->getHtml("[[base-maillists.ListRemoveConfirmInfo]]");
            $modal_remove = $i18n->getHtml("[[palette.remove]]");
            $modal_cancel = $i18n->getHtml("[[palette.cancel]]");
            $modal_html =<<<HTML

                        <!-- Delete-Confirm modal -->
                        <div id="dialog" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="dialogLabel" aria-hidden="true">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                                        <h5 class="modal-title" id="dialogLabel">$modal_title</h5>
                                    </div>
                                    <div class="modal-body">
                                        <p>$modal_body</p>
                                    </div>
                                    <div class="modal-footer">
                                        <button class="btn btn-danger btn-anim link_button" id="modalDeleteButton"><i class="fa fa-trash-o"></i><span class="btn-text">$modal_remove</span></button>
                                        <button class="btn btn-primary btn-anim" data-dismiss="modal"><i class="fa fa-times"></i><span class="btn-text">$modal_cancel</span></button>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- /Delete-Confirm modal -->

            HTML;
            $page_body[] = $modal_html;
        }

        $page_body[] = $block->toHtml();

        // Out with the page:
        return $BxPage->render($page_module, $page_body);

    }       
}

/*
Copyright (c) 2008-2024 Michael Stauber, SOLARSPEED.NET
Copyright (c) 2008-2024 Team BlueOnyx, BLUEONYX.IT
All Rights Reserved.

1. Redistributions of source code must retain the above copyright 
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright 
   notice, this list of conditions and the following disclaimer in 
   the documentation and/or other materials provided with the 
   distribution.

3. Neither the name of the copyright holder nor the names of its 
   contributors may be used to endorse or promote products derived 
   from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.

You acknowledge that this software is not designed or intended for 
use in the design, construction, operation or maintenance of any 
nuclear facility.

*/
?>